/**
 * PilrcEdit - a graphical editor for PilRC files.
 * Copyright (C) 2000 Rob Nielsen
 * rnielsen@wn.com.au
 * http://www.wn.com.au/rnielsen/
 *
 * Released under the GNU GPL - http://www.gnu.org/copyleft/gpl.html
 */
package pilrcedit;

import java.awt.event.*;
import java.awt.*;

public class CheckboxMenuItemGroup implements ItemListener
{
	ActionListener actionListener;
	CheckboxMenuItem selected;

	public void addActionListener(ActionListener l)
	{
		if (l==null)
		  return;
		actionListener = AWTEventMulticaster.add(actionListener, l);
	}

	public void removeItemListener(ActionListener l)
	{
		if (l==null)
		  return;
		actionListener = AWTEventMulticaster.remove(actionListener, l);
	}

	public void add(CheckboxMenuItem cmi)
	{
		if (selected==null)
		{
		  if (cmi.getState())
		    selected=cmi;
		}
		else
		if (cmi.getState())
		  cmi.setState(false);
		cmi.addItemListener(this);
	}

	public void remove(CheckboxMenuItem cmi)
	{
		cmi.removeItemListener(this);
	}


  public void select(CheckboxMenuItem cmi)
  {
		if (selected==cmi)
		  return;
		if (selected!=null)
		  selected.setState(false);
		selected=cmi;
		selected.setState(true);
	}

	public void itemStateChanged(ItemEvent e)
	{
		if (e.getSource()==selected)
		{
			if (e.getStateChange()==e.DESELECTED)
			  selected.setState(true);
	  }
	  else
	  if (e.getStateChange()==e.SELECTED)
	  {
			if (selected!=null)
			  selected.setState(false);
			selected=(CheckboxMenuItem)e.getSource();
			actionListener.actionPerformed(new ActionEvent(selected,
			  ActionEvent.ACTION_PERFORMED,selected.getActionCommand()));
		}
	}
}