/**
 * PilrcEdit - a graphical editor for PilRC files.
 * Copyright (C) 2000 Rob Nielsen
 * rnielsen@wn.com.au
 * http://www.wn.com.au/rnielsen/
 *
 * Released under the GNU GPL - http://www.gnu.org/copyleft/gpl.html
 */
package pilrcedit;

import java.awt.*;
import java.awt.event.*;

public class ControlList extends Frame
  implements FormListener,SelectionListener,ItemListener
{
  Editor editor;
  Form form;
  FormObject control;
  List list;

  public ControlList(Editor editor)
  {
    super("Form Control List");
    this.editor=editor;
    add(list=new List());
    list.addItemListener(this);
    setSize(200,300);
    Preferences.registerFrame(this,true);
  }

  private void populateList()
  {
    FormObject obj=form.getFirstObject();
    list.removeAll();
    int index=-1;
    int i=0;
    while(obj!=null)
    {
      if (obj==control)
        index=i;
      list.add(obj.toString());
      obj=obj.next();
      i++;
    }
    list.select(index);
  }

  public void itemStateChanged(ItemEvent e)
  {
    int index=list.getSelectedIndex();
    if (index==-1)
      return;
    FormObject obj=form.getFirstObject();
    while(obj!=null&&index>0)
    {
      obj=obj.next();
      index--;
    }
    if (obj!=null)
      editor.setSelected(obj);
  }

  public void formControlStructureChanged(Form form)
  {
    populateList();
  }

  public void formSelected(Form newForm)
  {
    if (form!=null)
      form.removeFormListener(this);
    form=newForm;
    if (form!=null)
    {
      form.addFormListener(this);
      populateList();
    }
  }

  public void controlSelected(FormObject control)
  {
    this.control=control;
    if (control==null||control==form)
    {
      list.select(-1);
      return;
    }
    FormObject obj=form.getFirstObject();
    int index=0;
    while(obj!=null&&obj!=control)
    {
      obj=obj.next();
      index++;
    }
    list.select(index);
  }

  public void editorKeyPressed(java.awt.event.KeyEvent e) {}
}