/**
 * PilrcEdit - a graphical editor for PilRC files.
 * Copyright (C) 2000 Rob Nielsen
 * rnielsen@wn.com.au
 * http://www.wn.com.au/rnielsen/
 *
 * Released under the GNU GPL - http://www.gnu.org/copyleft/gpl.html
 */
package pilrcedit;

import java.io.*;
//import javax.swing.*;

public class Debug
{
	public void handle(Throwable t)
	{
		debug(t);
	}

  public static void debug()
  {
		debug(new Throwable());
	}

	public static void debug(int len)
	{
		debug(new Throwable(),len);
	}

  public static void debug(Throwable t)
  {
		debug(t,6);
	}

  public static void debug(Throwable t,int len)
  {
		CharArrayWriter caw=new CharArrayWriter();
		t.printStackTrace(new PrintWriter(caw));
		String s=caw.toString();
		int pos=-1;
		for(int i=0;i<=len;i++)
		  pos=s.indexOf('\n',pos+1);
    if (pos==-1)
		  dialog(s);
		else
			dialog(s.substring(0,pos));
	}

	public static void debug(String s)
	{
		dialog(s);
	}

	public static void dialog(String s)
	{
		System.out.println(s);
    /*
		JOptionPane.showMessageDialog(null,
		  "An error has occured in the program and has been logged in the file \"error.txt\" \n\n"+s,
		  "Error!",JOptionPane.ERROR_MESSAGE);
      */
    try
    {
      PrintWriter pw=new PrintWriter(new FileWriter("error.txt",true));
      pw.println("*******************************************");
      pw.println(new java.util.Date());
      pw.println(s);
      pw.close();
    }
    catch(Exception e)
    {
      System.out.println(e);
    }
	}
}