/**
 * PilrcEdit - a graphical editor for PilRC files.
 * Copyright (C) 2000 Rob Nielsen
 * rnielsen@wn.com.au
 * http://www.wn.com.au/rnielsen/
 *
 * Released under the GNU GPL - http://www.gnu.org/copyleft/gpl.html
 */
package pilrcedit;

import java.awt.Component;
import java.awt.event.FocusListener;
import java.awt.event.FocusEvent;

public class Focuser extends Thread implements FocusListener
{
	Component c;
	boolean focusGained=false;

	public Focuser(Component c)
	{
		this.c=c;
		c.addFocusListener(this);
	}

  public void focusGained(FocusEvent e)
  {
		c.removeFocusListener(this);
		focusGained=true;
		c.requestFocus();
	}

	public void focusLost(FocusEvent e) {}

	public void run()
	{
		while (!focusGained)
		{
			c.requestFocus();
			try
			{
				sleep(100);
			}
			catch(InterruptedException e)
			{
			}
		}
	}
}